/*******************************************************************************
 * The MIT License
 * 
 * Copyright (c) 2009 OpenCGD Project
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 ******************************************************************************/
package opencgd.client.library;

import java.awt.Event;
import java.awt.Frame;
import java.awt.Graphics;

public class EngineFrame extends Frame {
	
	private static final long serialVersionUID = -5103227993732234369L;
	private EngineApplet f;
	private int c;
	private int b;
	private int d;
	private int a;
	
	@Override
	public final void paint(Graphics g){
		f.paint(g);
	}
	
	//FIXME Deprecation
	@SuppressWarnings("deprecation")
	@Override
	public boolean handleEvent(Event event){
		if(event.id == 401){
			f.keyDown(event, event.key);
		} else if(event.id == 402){
			f.keyUp(event, event.key);
		} else if(event.id == 501){
			f.mouseDown(event, event.x, event.y - 24);
		} else if(event.id == 506){
			f.mouseDrag(event, event.x, event.y - 24);
		} else if(event.id == 502){
			f.mouseUp(event, event.x, event.y - 24);
		} else if(event.id == 503){
			f.mouseMove(event, event.x, event.y - 24);
		} else if(event.id == 201){
			f.destroy();
		} else if(event.id == 1001){
			f.action(event, event.target);
		} else if(event.id == 403){
			f.keyDown(event, event.key);
		} else if(event.id == 404){
			f.keyUp(event, event.key);
		}
		return true;
	}
	
	public int b(){
		return getSize().height - c;
	}
	
	public int a(){
		return getSize().width;
	}
	
	@Override
	public void setSize(int i, int j){
		super.setSize(i, j + c);
	}
	
	@Override
	public Graphics getGraphics(){
		Graphics g = super.getGraphics();
		if(b == 0){
			g.translate(0, 24);
		} else {
			g.translate(-5, 0);
		}
		return g;
	}
	
	public EngineFrame(EngineApplet h1, int i, int j, String s, boolean flag, boolean flag1){
		c = flag1 ? 48 : 28;
		a = i;
		d = j;
		f = h1;
		setTitle(s);
		setResizable(flag);
		setVisible(true);
		toFront();
		setSize(a, d);
	}
}
