/*******************************************************************************
 * The MIT License
 * 
 * Copyright (c) 2009 OpenCGD Project
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 ******************************************************************************/
package opencgd.server.io;

import java.io.UnsupportedEncodingException;

public class FrameReader extends Frame {
	
	public FrameReader(Frame frame){
		super(frame);
	}
	
	public byte readByte(){
		return data[index++];
	}
	
	public byte[] readBytes(int length){
		final byte[] ba = new byte[length];
		System.arraycopy(data, index, ba, 0, length);
		index += length;
		return ba;
	}
	
	public short readShort(){
		return (short) ((short) ((readByte() & 0xff) << 8) | (short) (readByte() & 0xff));
	}
	
	public int readInt(){
		return ((readByte() & 0xff) << 24) | ((readByte() & 0xff) << 16) | ((readByte() & 0xff) << 8) | (readByte() & 0xff);
	}
	
	public long readLong(){
		return ((long) (readByte() & 0xff) << 56) | ((long) (readByte() & 0xff) << 48) | ((long) (readByte() & 0xff) << 40) | ((long) (readByte() & 0xff) << 32) | ((long) (readByte() & 0xff) << 24) | ((long) (readByte() & 0xff) << 16) | ((long) (readByte() & 0xff) << 8) | ((readByte() & 0xff));
	}
	
	public String readString() throws UnsupportedEncodingException {
		//TODO Read a length int instead... this is too risky
		
		final int start = index;
		
		while (data[index++] != 10);
		
		return new String(data, start, index - start - 1, "UTF-8");
	}
}
